%     VIRTUAL SORIC - программа для получения эффективных свойств заполнителей SORIC
%     Copyright (C) 2020  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function EL_Array = Mesh_Layer_C3D6(Node_Array_Bottom, Node_Array_Top, N_Elements_Edge)

N_elm_layer = 6;

EL_Array = zeros (N_elm_layer, 7);

% Элемент 1
EL_Array(1,1) = 2;
EL_Array(1,2) = Node_Array_Bottom((N_Elements_Edge+1)^2,1);
EL_Array(1,3) = Node_Array_Bottom((N_Elements_Edge+1)^2 + (N_Elements_Edge+1),1);
EL_Array(1,4) = Node_Array_Bottom((N_Elements_Edge+1)^2*2 + (2*(N_Elements_Edge+1)-1)*N_Elements_Edge + 1,1);
EL_Array(1,5) = Node_Array_Top((N_Elements_Edge+1)^2,1);
EL_Array(1,6) = Node_Array_Top((N_Elements_Edge+1)^2 + (N_Elements_Edge+1),1);
EL_Array(1,7) = Node_Array_Top((N_Elements_Edge+1)^2*2 + (2*(N_Elements_Edge+1)-1)*N_Elements_Edge + 1,1);

% Элемент 2
EL_Array(2,1) = 2;
EL_Array(2,2) = Node_Array_Bottom((N_Elements_Edge+1),1);
EL_Array(2,3) = Node_Array_Bottom((N_Elements_Edge+1)^2*2 + 1,1);
EL_Array(2,4) = Node_Array_Bottom((N_Elements_Edge+1)^2*4+(2*(N_Elements_Edge+1)-1)^2 + 1,1);
EL_Array(2,5) = Node_Array_Top((N_Elements_Edge+1),1);
EL_Array(2,6) = Node_Array_Top((N_Elements_Edge+1)^2*2 + 1,1);
EL_Array(2,7) = Node_Array_Top((N_Elements_Edge+1)^2*4+(2*(N_Elements_Edge+1)-1)^2 + 1,1);

% Элемент 3
EL_Array(3,1) = 2;
EL_Array(3,2) = Node_Array_Bottom((N_Elements_Edge+1)^2*2,1);
EL_Array(3,3) = Node_Array_Bottom((N_Elements_Edge+1)^2*4+(2*(N_Elements_Edge+1)-1)^2 + (2*(N_Elements_Edge+1)-1) + 1,1);
EL_Array(3,4) = Node_Array_Bottom((N_Elements_Edge+1)^2*2+(2*(N_Elements_Edge+1)-1)^2 - (2*(N_Elements_Edge+1)-1) + 1,1);
EL_Array(3,5) = Node_Array_Top((N_Elements_Edge+1)^2*2,1);
EL_Array(3,6) = Node_Array_Top((N_Elements_Edge+1)^2*4+(2*(N_Elements_Edge+1)-1)^2 + (2*(N_Elements_Edge+1)-1) + 1,1);
EL_Array(3,7) = Node_Array_Top((N_Elements_Edge+1)^2*2+(2*(N_Elements_Edge+1)-1)^2 - (2*(N_Elements_Edge+1)-1) + 1,1);

% Элемент 4
EL_Array(4,1) = 2;
EL_Array(4,2) = Node_Array_Bottom((N_Elements_Edge+1)^2*4+(2*(N_Elements_Edge+1)-1)^2 + (2*(N_Elements_Edge+1)-1),1);
EL_Array(4,3) = Node_Array_Bottom((N_Elements_Edge+1)^2*2 + (2*(N_Elements_Edge+1)-1),1);
EL_Array(4,4) = Node_Array_Bottom((N_Elements_Edge+1)^2*2+(2*(N_Elements_Edge+1)-1)^2 + 1,1);
EL_Array(4,5) = Node_Array_Top((N_Elements_Edge+1)^2*4+(2*(N_Elements_Edge+1)-1)^2 + (2*(N_Elements_Edge+1)-1),1);
EL_Array(4,6) = Node_Array_Top((N_Elements_Edge+1)^2*2 + (2*(N_Elements_Edge+1)-1),1);
EL_Array(4,7) = Node_Array_Top((N_Elements_Edge+1)^2*2+(2*(N_Elements_Edge+1)-1)^2 + 1,1);

% Элемент 5
EL_Array(5,1) = 2;
EL_Array(5,2) = Node_Array_Bottom((N_Elements_Edge+1)^2*2+(2*(N_Elements_Edge+1)-1)^2,1);
EL_Array(5,3) = Node_Array_Bottom((N_Elements_Edge+1)^2*4+(2*(N_Elements_Edge+1)-1)^2 + 2*(2*(N_Elements_Edge+1)-1),1);
EL_Array(5,4) = Node_Array_Bottom((N_Elements_Edge+1)^2*4+(2*(N_Elements_Edge+1)-1)^2 - (N_Elements_Edge+1) + 1,1);
EL_Array(5,5) = Node_Array_Top((N_Elements_Edge+1)^2*2+(2*(N_Elements_Edge+1)-1)^2,1);
EL_Array(5,6) = Node_Array_Top((N_Elements_Edge+1)^2*4+(2*(N_Elements_Edge+1)-1)^2 + 2*(2*(N_Elements_Edge+1)-1),1);
EL_Array(5,7) = Node_Array_Top((N_Elements_Edge+1)^2*4+(2*(N_Elements_Edge+1)-1)^2 - (N_Elements_Edge+1) + 1,1);

% Элемент 6
EL_Array(6,1) = 2;
EL_Array(6,2) = Node_Array_Bottom((N_Elements_Edge+1)^2*2+(2*(N_Elements_Edge+1)-1)*(N_Elements_Edge+1),1);
EL_Array(6,3) = Node_Array_Bottom((N_Elements_Edge+1)^2*3+(2*(N_Elements_Edge+1)-1)^2 + 1,1);
EL_Array(6,4) = Node_Array_Bottom((N_Elements_Edge+1)^2*3+(2*(N_Elements_Edge+1)-1)^2 - (N_Elements_Edge+1) + 1,1);
EL_Array(6,5) = Node_Array_Top((N_Elements_Edge+1)^2*2+(2*(N_Elements_Edge+1)-1)*(N_Elements_Edge+1),1);
EL_Array(6,6) = Node_Array_Top((N_Elements_Edge+1)^2*3+(2*(N_Elements_Edge+1)-1)^2 + 1,1);
EL_Array(6,7) = Node_Array_Top((N_Elements_Edge+1)^2*3+(2*(N_Elements_Edge+1)-1)^2 - (N_Elements_Edge+1) + 1,1);
